' Skinmesh demo.

' THIS SOURCE CODE IS PROVIDED "AS IS" WITHOUT WARRANTY OF ANY KIND. USE AT YOUR OWN RISK.

Strict
Framework _3Impact.Lib

Include "..\common\3impact_cameraman.bmx"

Global Camera:CAMERA
Global LoadingMessage:SPRITE
Global SkyBox:SKYBOX
Global Terrain:BODY
Global TerrainMesh:MESH
Global Ball:BODY
Global BallMesh:MESH
Global BallMeshShadow:MESH
Global BallTerrain:BODYBODY

Global CMKD:CameramanLookAtPointKeepDistance_t=New CameramanLookAtPointKeepDistance_t

Global SkinMesh:SKINMESH
Global SkinMeshShadow:SKINMESH

If Not i3ImpactOpen() RuntimeError "Unable to initialize the 3Impact game engine"
If Not i3ImpactSettings(_ISETTINGS(640,480,32,False,True,False)) RuntimeError "Settings failed"

Local engine:sample_3IEngine=New sample_3IEngine

engine.Start()

Type sample_3IEngine Extends _3IEngine

	Method _Init()
	   Camera=iCameraCreate(0.0,0.0,1.0,1.0)
	   iCameraLocationSet(Camera,_D3DXVECTOR3(-10.0,3.0,-10.0))
	   CMKD.Create(Camera,1.0,15.0,3.0,20.0,0.9,0.35,Null)
	
	   iLightDirectionalSet(_D3DXVECTOR3(1.0,-1.0,1.0),_D3DXVECTOR4(1.0,1.0,1.0,0.35))
	
	   LoadingMessage=iSpriteCreate("default_res\\sprites\\loading.x",Null)
	   iSpriteRender(LoadingMessage,False)
	
	   SkyBox=iSkyBoxCreate("default_res\\skyboxes\\skybox01.sky")
	
	   Terrain=iBodyCreate("default_res\\terrain_5.00.ply")
	   TerrainMesh=iBodyMeshCreate("default_res\\terrain.x",Terrain)
	
	   Ball=iBodySGCreate("default_res\\ball_.spg",0.13)
	   BallMesh=iBodyMeshCreate("default_res\\ball.x",Ball)
	   iBodyLocationSet(Ball,_D3DXVECTOR3(0.0,5.0,0.0),True)
	   iBodyDampingSet(Ball,0.0,0.999,0.0,0.995)
	
	   BallMeshShadow=iMeshBodyShadowCasterCreate("default_res\\ball_shadow.x",Ball,500.0)
	
	   BallTerrain=iBodyBodyCreate(Ball,Terrain)
	   iBodyBodyFrictionSet(BallTerrain,10.0)
	
	   ' create a skinmesh from an .x file containing bone-based animation information
	   SkinMesh=iSkinMeshCreate("default_res\\animal.x",Null)
	   ' place the animated mesh
	   iSkinMeshEulerOrientationSet(SkinMesh,0.0,0.0,0.0,"xyz")
	   iSkinMeshLocationSet(SkinMesh,_D3DXVECTOR3(0.0,5.0,0.0))
	   ' reset animation time To zero
	   iSkinMeshAnimationTimeSet(SkinMesh,0.0)
	   ' set animation speed.
	   iSkinMeshAnimationSpeedSet(SkinMesh,50.0)
	
	   ' create a shadow caster skinmesh.
	   ' The source .x file contains a bone-based animation that is identical To
	   ' the visible skinmesh animation (see above). It is basically the same
	   ' 3d model performing identical animation but with no texture mapping.
	   SkinMeshShadow=iSkinMeshShadowCasterCreate("default_res\\animal_shadow.x",20.0)
	   ' copy orientation, location And animation parameters from the visible
	   ' skinmesh To the shadow caster skinmesh, in order To synchronize the
	   ' visible mesh To the cast shadow effect.
	   iSkinMeshAnimationCopy(SkinMesh,SkinMeshShadow)
	
	   iBodyEnable(Terrain)
	   iBodyEnable(Ball)
	
	   iSpriteHide(LoadingMessage)
	   iSkyBoxShow(SkyBox)
	   iMeshShow(TerrainMesh)
	   iMeshShow(BallMesh)
	   iMeshShow(BallMeshShadow)
	   ' don't forget to show the skinmeshes created above!
	   iSkinMeshShow(SkinMesh)
	   iSkinMeshShow(SkinMeshShadow)
	EndMethod
	Method _Run()

	   Local actorlocation:D3DXVECTOR3=_D3DXVECTOR3()
	   iBodyLocationCM(Ball,actorlocation)
	
	   CMKD.Update(actorlocation)
	
	   Local acceleration:D3DXVECTOR3=_D3DXVECTOR3()
	   Local cameraorientation:D3DXQUATERNION=_D3DXQUATERNION()
	
	   acceleration=_D3DXVECTOR3(0.0,0.0,0.0)
	   If (iKeyDown(DIK_LEFT)) acceleration.PlusEq(_D3DXVECTOR3(-10.0,0.0,0.0))
	   If (iKeyDown(DIK_RIGHT)) acceleration.PlusEq(_D3DXVECTOR3(10.0,0.0,0.0))
	   If (iKeyDown(DIK_UP)) acceleration.PlusEq(_D3DXVECTOR3(0.0,0.0,10.0))
	   If (iKeyDown(DIK_DOWN)) acceleration.PlusEq(_D3DXVECTOR3(0.0,0.0,-10.0))
	
	   iCameraOrientation(Camera,cameraorientation)
	   iVectorRotate(acceleration,acceleration,cameraorientation)
	
	   acceleration.y = 0.0
	
	   iBodyAccelerationApply(Ball,acceleration)
	
	   If (Not iKeyDown(DIK_LCONTROL))
		 iBodyAccelerationApply(Ball,_D3DXVECTOR3(0.0,-9.80665,0.0))
	   Else
		 iBodyAccelerationApply(Ball,_D3DXVECTOR3(0.0,9.80665,0.0))
	   EndIf
	EndMethod
	Method _Exit()
	   CMKD=Null
	EndMethod
EndType
