
' -------------------------------------------------------
' BODYBODY
' -------------------------------------------------------

Type BODYBODY Extends i3ImpactBase

	Method Destroy()
		If Not IsValid() RuntimeError "Invalid BODYBODY"
		_iBodyBodyDestroy(objptr)
		objptr=Null
	EndMethod	

	Method Enable(bEnable:Int)
		If Not IsValid() RuntimeError "Invalid BODYBODY"
		_iBodyBodyEnable(objptr,bEnable)
	EndMethod
	
	Method CollisionResponseEnable(bEnable:Int)
		If Not IsValid() RuntimeError "Invalid BODYBODY"
		_iBodyBodyCollisionResponseEnable(objptr,bEnable)
	EndMethod
	
	Method RestitutionSet(restitution:Float)
		If Not IsValid() RuntimeError "Invalid BODYBODY"
		_iBodyBodyRestitutionSet(objptr,restitution)
	EndMethod
	
	Method FrictionSet(friction:Float)
		If Not IsValid() RuntimeError "Invalid BODYBODY"
		_iBodyBodyFrictionSet(objptr,friction)
	EndMethod
	
	Method FrictionModelSet(frictionModel:Int)
		If Not IsValid() RuntimeError "Invalid BODYBODY"
		_iBodyBodyFrictionModelSet(objptr,frictionModel)
	EndMethod
	
	Method SplitFrictionSet(sideFriction:Float,sideSlipFactor:Float,rollingFriction:Float,rollingSlipFactor:Float)
		If Not IsValid() RuntimeError "Invalid BODYBODY"
		_iBodyBodySplitFrictionSet(objptr,sideFriction,sideSlipFactor,rollingFriction,rollingSlipFactor)
	EndMethod
	
	Method SubpartRestitutionSet(firstSubPartIDX:Int,secondSubPartIDX:Int,restitution:Float)
		If Not IsValid() RuntimeError "Invalid BODYBODY"
		_iBodyBodySubpartRestitutionSet(objptr,firstSubPartIDX,secondSubPartIDX,restitution)
	EndMethod
	
	Method SubpartFrictionSet(firstSubPartIDX:Int,secondSubPartIDX:Int,friction:Float)
		If Not IsValid() RuntimeError "Invalid BODYBODY"
		_iBodyBodySubpartFrictionSet(objptr,firstSubPartIDX,secondSubPartIDX,friction)
	EndMethod
	
	Method SubpartFrictionModelSet(firstSubPartIDX:Int,secondSubPartIDX:Int,frictionModel:Int)
		If Not IsValid() RuntimeError "Invalid BODYBODY"
		_iBodyBodySubpartFrictionModelSet(objptr,firstSubPartIDX,secondSubPartIDX,frictionModel)
	EndMethod
	
	Method SubpartSplitFrictionSet(firstSubPartIDX:Int,secondSubPartIDX:Int,sideFriction:Float,sideSlipFactor:Float,rollingFriction:Float,rollingSlipFactor:Float)
		If Not IsValid() RuntimeError "Invalid BODYBODY"
		_iBodyBodySubpartSplitFrictionSet(objptr,firstSubPartIDX,secondSubPartIDX,sideFriction,sideSlipFactor,rollingFriction,rollingSlipFactor)
	EndMethod
	
	Method FeedbackEnable(firstSubPartIDX:Int,secondSubPartIDX:Int,bEnableContactFeedback:Int)
		If Not IsValid() RuntimeError "Invalid BODYBODY"
		_iBodyBodyFeedbackEnable(objptr,firstSubPartIDX,secondSubPartIDX,bEnableContactFeedback)
	EndMethod
	
	Method Feedback:Int(firstSubPartIDX:Int,secondSubPartIDX:Int,contactLocation:D3DXVECTOR3,contactNormal:D3DXVECTOR3,firstForce:D3DXVECTOR3,firstTorque:D3DXVECTOR3,secondForce:D3DXVECTOR3,secondTorque:D3DXVECTOR3)
		Local pContactLocation:Byte Ptr=Null
		Local pContactNormal:Byte Ptr=Null
		Local pFirstForce:Byte Ptr=Null
		Local pFirstTorque:Byte Ptr=Null
		Local pSecondForce:Byte Ptr=Null
		Local pSecondTorque:Byte Ptr=Null
			
		If contactLocation<>Null Then pContactLocation=contactLocation.param()
		If contactNormal<>Null Then pContactNormal=contactNormal.param()
		If firstForce<>Null Then pFirstForce=firstForce.param()
		If firstTorque<>Null Then pFirstTorque=firstTorque.param()
		If secondForce<>Null Then pSecondForce=secondForce.param()
		If secondTorque<>Null Then pSecondTorque=secondTorque.param()

		Return _iBodyBodyFeedback(objptr,firstSubPartIDX,secondSubPartIDX,pContactLocation,pContactNormal,pFirstForce,pFirstTorque,pSecondForce,pSecondTorque)
	EndMethod
		
EndType

Function iBodyBodyCreate:BODYBODY(firstBody:BODY,secondBody:BODY,generateFunc:Byte Ptr=Null)
	Return _g_3IEngine.BodyBodyCreate(firstBody,secondBody,generateFunc)	
EndFunction

Function iBodyBodyDestroy(bb:BODYBODY)
	If Not bb RuntimeError "BodyBody is Null"
	bb.Destroy()
EndFunction

Function iBodyBodyEnable(bb:BODYBODY,bEnable:Int)
	If Not bb RuntimeError "BodyBody is Null"
	bb.Enable(bEnable)
EndFunction

Function iBodyBodyCollisionResponseEnable(bb:BODYBODY,bEnable:Int)
	If Not bb RuntimeError "BodyBody is Null"
	bb.CollisionResponseEnable(bEnable)
EndFunction

Function iBodyBodyRestitutionSet(bb:BODYBODY,restitution:Float)
	If Not bb RuntimeError "BodyBody is Null"
	bb.RestitutionSet(restitution)
EndFunction

Function iBodyBodyFrictionSet(bb:BODYBODY,friction:Float)
	If Not bb RuntimeError "BodyBody is Null"
	bb.FrictionSet(friction)
EndFunction

Function iBodyBodyFrictionModelSet(bb:BODYBODY,frictionModel:Int)
	If Not bb RuntimeError "BodyBody is Null"
	bb.FrictionModelSet(frictionModel)
EndFunction

Function iBodyBodySplitFrictionSet(bb:BODYBODY,sideFriction:Float,sideSlipFactor:Float,rollingFriction:Float,rollingSlipFactor:Float)
	If Not bb RuntimeError "BodyBody is Null"
	bb.SplitFrictionSet(sideFriction,sideSlipFactor,rollingFriction,rollingSlipFactor)
EndFunction

Function iBodyBodySubpartRestitutionSet(bb:BODYBODY,firstSubPartIDX:Int,secondSubPartIDX:Int,restitution:Float)
	If Not bb RuntimeError "BodyBody is Null"
	bb.SubpartRestitutionSet(firstSubPartIDX,secondSubPartIDX,restitution)
EndFunction

Function iBodyBodySubpartFrictionSet(bb:BODYBODY,firstSubPartIDX:Int,secondSubPartIDX:Int,friction:Float)
	If Not bb RuntimeError "BodyBody is Null"
	bb.SubpartFrictionSet(firstSubPartIDX,secondSubPartIDX,friction)
EndFunction

Function iBodyBodySubpartFrictionModelSet(bb:BODYBODY,firstSubPartIDX:Int,secondSubPartIDX:Int,frictionModel:Int)
	If Not bb RuntimeError "BodyBody is Null"
	bb.SubpartFrictionModelSet(firstSubPartIDX,secondSubPartIDX,frictionModel)
EndFunction

Function iBodyBodySubpartSplitFrictionSet(bb:BODYBODY,firstSubPartIDX:Int,secondSubPartIDX:Int,sideFriction:Float,sideSlipFactor:Float,rollingFriction:Float,rollingSlipFactor:Float)
	If Not bb RuntimeError "BodyBody is Null"
	bb.SubpartSplitFrictionSet(firstSubPartIDX,secondSubPartIDX,sideFriction,sideSlipFactor,rollingFriction,rollingSlipFactor)
EndFunction

Function iBodyBodyFeedbackEnable(bb:BODYBODY,firstSubPartIDX:Int,secondSubPartIDX:Int,bEnableContactFeedback:Int)
	If Not bb RuntimeError "BodyBody is Null"
	bb.FeedbackEnable(firstSubPartIDX,secondSubPartIDX,bEnableContactFeedback)
EndFunction

Function iBodyBodyFeedback:Int(bb:BODYBODY,firstSubPartIDX:Int,secondSubPartIDX:Int,contactLocation:D3DXVECTOR3,contactNormal:D3DXVECTOR3,firstForce:D3DXVECTOR3,firstTorque:D3DXVECTOR3,secondForce:D3DXVECTOR3,secondTorque:D3DXVECTOR3)
	If Not bb RuntimeError "BodyBody is Null"
	Return bb.Feedback(firstSubPartIDX,secondSubPartIDX,contactLocation,contactNormal,firstForce,firstTorque,secondForce,secondTorque)
EndFunction

Extern

	' BODYBODY
	Function _iBodyBodyCreate:Byte Ptr(BODY_firstBody:Byte Ptr,BODY_secondBody:Byte Ptr)="iBodyBodyCreate" ' returns BODYBODY* 
	Function _iBodyBodyDestroy(BODYBODY:Byte Ptr)="iBodyBodyDestroy"
	Function _iBodyBodyEnable(BODYBODY:Byte Ptr,bEnable:Int)="iBodyBodyEnable"
	Function _iBodyBodyCollisionResponseEnable(BODYBODY:Byte Ptr,bEnable:Int)="iBodyBodyCollisionResponseEnable"
	Function _iBodyBodyRestitutionSet(BODYBODY:Byte Ptr,restitution:Float)="iBodyBodyRestitutionSet"
	Function _iBodyBodyFrictionSet(BODYBODY:Byte Ptr,friction:Float)="iBodyBodyFrictionSet"
	Function _iBodyBodyFrictionModelSet(BODYBODY:Byte Ptr,frictionModel:Int)="iBodyBodyFrictionModelSet"
	Function _iBodyBodySplitFrictionSet(BODYBODY:Byte Ptr,sideFriction:Float,sideSlipFactor:Float,rollingFriction:Float,rollingSlipFactor:Float)="iBodyBodySplitFrictionSet"
	Function _iBodyBodySubpartRestitutionSet(BODYBODY:Byte Ptr,firstSubPartIDX:Int,secondSubPartIDX:Int,restitution:Float)="iBodyBodySubpartRestitutionSet"
	Function _iBodyBodySubpartFrictionSet(BODYBODY:Byte Ptr,firstSubPartIDX:Int,secondSubPartIDX:Int,friction:Float)="iBodyBodySubpartFrictionSet"
	Function _iBodyBodySubpartFrictionModelSet(BODYBODY:Byte Ptr,firstSubPartIDX:Int,secondSubPartIDX:Int,frictionModel:Int)="iBodyBodySubpartFrictionModelSet"
	Function _iBodyBodySubpartSplitFrictionSet(BODYBODY:Byte Ptr,firstSubPartIDX:Int,secondSubPartIDX:Int,sideFriction:Float,sideSlipFactor:Float,rollingFriction:Float,rollingSlipFactor:Float)="iBodyBodySubpartSplitFrictionSet"
	Function _iBodyBodyFeedbackEnable(BODYBODY:Byte Ptr,firstSubPartIDX:Int,secondSubPartIDX:Int,bEnableContactFeedback:Int)="iBodyBodyFeedbackEnable"
	Function _iBodyBodyFeedback:Int(BODYBODY:Byte Ptr,firstSubPartIDX:Int,secondSubPartIDX:Int,D3DXVECTOR3_contactLocation:Byte Ptr,D3DXVECTOR3_contactNormal:Byte Ptr,D3DXVECTOR3_firstForce:Byte Ptr,D3DXVECTOR3_firstTorque:Byte Ptr,D3DXVECTOR3_secondForce:Byte Ptr,D3DXVECTOR3_secondTorque:Byte Ptr)="iBodyBodyFeedback"
	
EndExtern
