Strict

Rem
bbdoc: 3Impact v5.2.1 library
End Rem
Module _3Impact.Lib

ModuleInfo "Version: 1.05"
ModuleInfo "Author: gman"
ModuleInfo "License: freebie"

Import BRL.Bank
Import BRL.FileSystem
Import BRL.Stream
Import Pub.Win32

?Debug
Import "../libs/libdll3impactd.a"
?Not Debug
Import "../libs/libdll3impact.a"
?

Import "3impact.cpp"

Include "const.bmx"
Include "engine.bmx"
Include "skybox.bmx"
Include "camera.bmx"
Include "light.bmx"
Include "body.bmx"
Include "bodybody.bmx"
Include "joints.bmx"
Include "mesh.bmx"
Include "skinmesh.bmx"
Include "shadow.bmx"
Include "envmap.bmx"
Include "sprite.bmx"
Include "particle.bmx"
Include "trail.bmx"
Include "texture.bmx"
Include "output.bmx"
Include "input.bmx"
Include "spring.bmx"
Include "sound.bmx"
Include "network.bmx"
Include "file.bmx"
Include "dialogs.bmx"
Include "render.bmx"
Include "math.bmx"
Include "replay.bmx"
Include "structures.bmx"

Rem
	TODO:
		- DIJOYSTICK2 structure in input.bmx
EndRem


Type i3ImpactBase
	Field objptr:Byte Ptr=Null
	Method IsValid:Int()
		Return objptr<>Null
	EndMethod

	Method Delete()
		If IsValid() Destroy()
	EndMethod
	
	Method Destroy()
	EndMethod
	
	Method IsEq:Int(other:i3ImpactBase)
		Return objptr=other.objptr
	EndMethod
EndType

Extern
		
	' PROCESSING
	Function iExit()
	Function iEscEnable(bEnable:Int)
	Function iSettingsPanelSkip(bSkip:Int)
	Function iFrq:Float()
	Function iSimulationFrqSet(frequency:Float)
	Function iPhysicsAccuracySet(accuracy:Float)
	Function iSystemTimer:Float()
	Function iTic:Int()
	Function iEdgeCollisionCheckSet(bEnable:Int)
	Function iBoundingSphereCollisionCheckSet(bEnable:Int)
	Function iReset(bRunExitBefore:Int,bRunInitAfter:Int)
	Function iProcessMessages()
	Function iCleanResetEnable(bEnable:Int)
	Function iFrqSet(freq:Float)
EndExtern

