Type _3INETWORK

	Method ServerStart:Int(sessionName:String,playerName:String,port:Int,gameID:Int,bufferSize:Int)
		Return _iNetServerStart(sessionName,playerName,port,gameID,bufferSize)
	EndMethod 
	
	Method ClientStart:Int(serverIP:String,playerName:String,gameID:Int,bufferSize:Int,dialogTitle:String,remoteSequentialNumber:Int,gameSearchingTimeout:Int,connectSprite:SPRITE=Null)
		If connectSprite=Null Then connectSprite=New SPRITE
		Return _iNetClientStart(serverIP,playerName,gameID,bufferSize,dialogTitle,remoteSequentialNumber,gameSearchingTimeout,connectSprite.objptr)
	EndMethod 
	
	Method Stop()
		_iNetStop()
	EndMethod 
	
	Method ClientDisconnect(playerID:Int)
		_iNetClientDisconnect(playerID)
	EndMethod 
	
	Method BodySyncCreate:BODYSYNC(bdy:BODY,syncFrequency:Float,generateFunc:Byte Ptr=Null)
		Return _g_3IEngine.BodySyncCreate(bdy,syncFrequency,generateFunc) 
	EndMethod 
	
	Method BodySyncDestroy(bdysync:BODYSYNC)
		bdysync.Destroy()
	EndMethod 
	
	Method FloatSyncCreate:FLOATSYNC(syncVar:Float Var,syncFrequency:Float,minSyncFrequency:Float,variationThreshold:Float,generateFunc:Byte Ptr=Null)
		Return _g_3IEngine.FloatSyncCreate(Varptr(syncVar),syncFrequency,minSyncFrequency,variationThreshold,generateFunc)
	EndMethod 
	
	Method FloatSyncUpdate:Int(fsync:FLOATSYNC,newValue:Float)
		Return fsync.Update(newValue)
	EndMethod 
	
	Method FloatSyncDestroy(fsync:FLOATSYNC)
		fsync.Destroy()
	EndMethod 
	
	Method ClientReset()
		_iNetClientReset()
	EndMethod 
	
	Method ServerSendFrqSet(maxSendFrequency:Float)
		_iNetServerSendFrqSet(maxSendFrequency)
	EndMethod 
	
	Method ClientSendFrqSet(maxSendFrequency:Float)
		_iNetClientSendFrqSet(maxSendFrequency)
	EndMethod 
	
	Method SessionTerminated:Int()
		Return _iNetSessionTerminated()
	EndMethod 
	
	Method ClientSync:Float()
		Return _iNetClientSync()
	EndMethod 
	
	Method PlayersChanged:Int()
		Return _iNetPlayersChanged()
	EndMethod 
	
	Method PlayersCount:Int()
		Return _iNetPlayersCount()
	EndMethod 
	
	Method PlayerMachine:Int(playerID:Int)
		Return _iNetPlayerMachine(playerID)
	EndMethod 
	
	Method LocalPlayerMachine:Int()
		Return _iNetLocalPlayerMachine()
	EndMethod 
	
	Method PlayerId(machineID:Int,playerID:Int Var)
		_iNetPlayerId(machineID,Varptr(playerID))
	EndMethod 
	
	Method PlayerName(playerID:Int,playerName:String Var)
		Local buf:TBank=CreateBank(1024)
		Local retval:Int=_iNetPlayerName(playerID,BankBuf(buf))
		playerName=String.FromCString(BankBuf(buf))
		buf=Null
		Return retval
	EndMethod 
	
	Method DataSend(sendData:String,bytesToSend:Int,messageID:Int,playerID:Int,bGuaranteed:Int)
		_iNetDataSend(sendData,bytesToSend,messageID,playerID,bGuaranteed)
	EndMethod 
	
	Method Data:Int(recvData:Byte Ptr Ptr,messageID:Int Ptr,machineID:Int Ptr)
		Local retval:Int
		retval=_iNetData(recvData,messageID,machineID)
		Return retval
	EndMethod 
	
	Method DataDiscard:Int()
		Return _iNetDataDiscard()
	EndMethod 
	
	Method Lag:Float(machineID:Int)
		Return iNetLag(machineID)
	EndMethod 
	
	Method MinimumLag:Float()
		Return _iNetMinimumLag()
	EndMethod 
	
	Method BPS:Int(machineID:Int)
		Return _iNetBPS(machineID)
	EndMethod 
	
	Method BytesSent:Int(machineID:Int)
		Return _iNetBytesSent(machineID)
	EndMethod 
	
	Method BytesReceived:Int(machineID:Int)
		Return _iNetBytesReceived(machineID)
	EndMethod 
	
	Method IgnoreContacts(bIgnoreContact:Int)
		_iNetIgnoreContacts(bIgnoreContact)
	EndMethod 
	
EndType

Type BODYSYNC Extends i3ImpactBase
	Method Destroy()
		_iNetBodySyncDestroy(objptr)
		objptr=Null
	EndMethod
EndType

Type FLOATSYNC Extends i3ImpactBase

	Method Update:Int(newValue:Float)
		Return _iNetFloatSyncUpdate(objptr,newValue)
	EndMethod
	
	Method Destroy()
		_iNetFloatSyncDestroy(objptr)
		objptr=Null
	EndMethod
EndType

Function iNetServerStart:Int(sessionName:String,playerName:String,port:Int,gameID:Int,bufferSize:Int)
	Return _g_3IEngine.network.ServerStart(sessionName,playerName,port,gameID,bufferSize)
EndFunction

Function iNetClientStart:Int(serverIP:String,playerName:String,gameID:Int,bufferSize:Int,dialogTitle:String,remoteSequentialNumber:Int,gameSearchingTimeout:Int,connectSprite:SPRITE=Null)
	Return _g_3IEngine.network.ClientStart(serverIP,playerName,gameID,bufferSize,dialogTitle,remoteSequentialNumber,gameSearchingTimeout,connectSprite)
EndFunction

Function iNetStop()
	_g_3IEngine.network.Stop()
EndFunction

Function iNetClientDisconnect(playerID:Int)
	_g_3IEngine.network.ClientDisconnect(playerID)
EndFunction

Function iNetBodySyncCreate:BODYSYNC(bdy:BODY,syncFrequency:Float,generateFunc:Byte Ptr=Null)
	Return _g_3IEngine.network.BodySyncCreate(bdy,syncFrequency,generateFunc) 
EndFunction

Function iNetBodySyncDestroy(bdysync:BODYSYNC)
	_g_3IEngine.network.BodySyncDestroy(bdysync)
EndFunction

Function iNetFloatSyncCreate:FLOATSYNC(syncVar:Float Var,syncFrequency:Float,minSyncFrequency:Float,variationThreshold:Float,generateFunc:Byte Ptr=Null)
	Return _g_3IEngine.network.FloatSyncCreate(syncVar,syncFrequency,minSyncFrequency,variationThreshold,generateFunc)
EndFunction

Function iNetFloatSyncUpdate:Int(fsync:FLOATSYNC,newValue:Float)
	Return _g_3IEngine.network.FloatSyncUpdate(fsync,newValue)
EndFunction

Function iNetFloatSyncDestroy(fsync:FLOATSYNC)
	_g_3IEngine.network.FloatSyncDestroy(fsync)
EndFunction

Function iNetClientReset()
	_g_3IEngine.network.ClientReset()
EndFunction

Function iNetServerSendFrqSet(maxSendFrequency:Float)
	_g_3IEngine.network.ServerSendFrqSet(maxSendFrequency)
EndFunction

Function iNetClientSendFrqSet(maxSendFrequency:Float)
	_g_3IEngine.network.ClientSendFrqSet(maxSendFrequency)
EndFunction

Function iNetSessionTerminated:Int()
	Return _g_3IEngine.network.SessionTerminated()
EndFunction

Function iNetClientSync:Float()
	Return _g_3IEngine.network.ClientSync()
EndFunction

Function iNetPlayersChanged:Int()
	Return _g_3IEngine.network.PlayersChanged()
EndFunction

Function iNetPlayersCount:Int()
	Return _g_3IEngine.network.PlayersCount()
EndFunction

Function iNetPlayerMachine:Int(playerID:Int)
	Return _g_3IEngine.network.PlayerMachine(playerID)
EndFunction

Function iNetLocalPlayerMachine:Int()
	Return _g_3IEngine.network.LocalPlayerMachine()
EndFunction

Function iNetPlayerId(machineID:Int,playerID:Int Var)
	_g_3IEngine.network.PlayerId(machineID,playerID)
EndFunction

Function iNetPlayerName(playerID:Int,playerName:String Var)
	_g_3IEngine.network.PlayerName(playerID,playerName)
EndFunction

Function iNetDataSend(sendData:String,bytesToSend:Int,messageID:Int,playerID:Int,bGuaranteed:Int)
	_g_3IEngine.network.DataSend(sendData,bytesToSend,messageID,playerID,bGuaranteed)
EndFunction

Function iNetData:Int(recvData:Byte Ptr Ptr,messageID:Int Ptr,machineID:Int Ptr)
	Return _g_3IEngine.network.Data(recvData,messageID,machineID)
EndFunction

Function iNetDataDiscard:Int()
	Return _g_3IEngine.network.DataDiscard()
EndFunction

Function iNetLag:Float(machineID:Int)
	Return iNetLag(machineID)
EndFunction

Function iNetMinimumLag:Float()
	Return _g_3IEngine.network.MinimumLag()
EndFunction

Function iNetBPS:Int(machineID:Int)
	Return _g_3IEngine.network.BPS(machineID)
EndFunction

Function iNetBytesSent:Int(machineID:Int)
	Return _g_3IEngine.network.BytesSent(machineID)
EndFunction

Function iNetBytesReceived:Int(machineID:Int)
	Return _g_3IEngine.network.BytesReceived(machineID)
EndFunction

Function iNetIgnoreContacts(bIgnoreContact:Int)
	_g_3IEngine.network.IgnoreContacts(bIgnoreContact)
EndFunction

Extern

	' NETWORK
	Function _iNetServerStart:Int(sessionName$z,playerName$z,port:Int,gameID:Int,bufferSize:Int)="iNetServerStart" ' returns true/false
	Function _iNetClientStart:Int(serverIP$z,playerName$z,gameID:Int,bufferSize:Int,dialogTitle$z,remoteSequentialNumber:Int,gameSearchingTimeout:Int,SPRITE:Byte Ptr=Null)="iNetClientStart" ' returns true/false
	Function _iNetStop()="iNetStop"
	Function _iNetClientDisconnect(playerID:Int)="iNetClientDisconnect"
	Function _iNetBodySyncCreate:Byte Ptr(BODY:Byte Ptr,syncFrequency:Float)="iNetBodySyncCreate" ' returns BODYSYNC*
	Function _iNetBodySyncDestroy(BODYSYNC:Byte Ptr)="iNetBodySyncDestroy"
	Function _iNetFloatSyncCreate:Byte Ptr(syncVar:Float Ptr,syncFrequency:Float,minSyncFrequency:Float,variationThreshold:Float)="iNetFloatSyncCreate" ' returns FLOATSYNC*
	Function _iNetFloatSyncUpdate:Int(FLOATSYNC:Byte Ptr,newValue:Float)="iNetFloatSyncUpdate" ' returns true/false
	Function _iNetFloatSyncDestroy(FLOATSYNC:Byte Ptr)="iNetFloatSyncDestroy"
	Function _iNetClientReset()="iNetClientReset"
	Function _iNetServerSendFrqSet(maxSendFrequency:Float)="iNetServerSendFrqSet"
	Function _iNetClientSendFrqSet(maxSendFrequency:Float)="iNetClientSendFrqSet"
	Function _iNetSessionTerminated:Int()="iNetSessionTerminated" ' returns true/false
	Function _iNetClientSync:Float()="iNetClientSync"
	Function _iNetPlayersChanged:Int()="iNetPlayersChanged"  ' returns true/false
	Function _iNetPlayersCount:Int()="iNetPlayersCount"
	Function _iNetPlayerMachine:Int(playerID:Int)="iNetPlayerMachine"
	Function _iNetLocalPlayerMachine:Int()="iNetLocalPlayerMachine"
	Function _iNetPlayerId:Int(machineID:Int,playerID:Byte Ptr)="iNetPlayerId" ' returns true/false
	Function _iNetPlayerName:Int(playerID:Int,playerName:Byte Ptr)="iNetPlayerName" ' returns true/false
	Function _iNetDataSend(sendData$z,bytesToSend:Int,messageID:Int,playerID:Int,bGuaranteed:Int)="iNetDataSend"
	Function _iNetData:Int(recvData:Byte Ptr Ptr,messageID:Int Ptr,machineID:Int Ptr)="iNetData"
	Function _iNetDataDiscard:Int()="iNetDataDiscard"
	Function _iNetLag:Float(machineID:Int)="iNetLag"
	Function _iNetMinimumLag:Float()="iNetMinimumLag"
	Function _iNetBPS:Int(machineID:Int)="iNetBPS"
	Function _iNetBytesSent:Int(machineID:Int)="iNetBytesSent"
	Function _iNetBytesReceived:Int(machineID:Int)="iNetBytesReceived"
	Function _iNetIgnoreContacts(bIgnoreContact:Int)="iNetIgnoreContacts"
	
EndExtern
