
Type FONT Extends i3ImpactBase	

	Method Destroy()
		_iFontDestroy(objptr)
	EndMethod
	
	Method Print(text:String,location:D3DXVECTOR2,scaling:D3DXVECTOR2,spacing:Float)
		_iPrint(text,location.param(),scaling.param(),spacing,objptr)
	EndMethod
	
	Method PrintCentered(text:String,location:D3DXVECTOR2,scaling:D3DXVECTOR2,spacing:Float,shrinkToWidth:Float)
		_iPrintCentered(text,location.param(),scaling.param(),spacing,objptr,shrinkToWidth)
	EndMethod
	
	Method PrintWidth:Float(text:String,scaling:D3DXVECTOR2,spacing:Float)
		Return _iPrintWidth(text,scaling.param(),spacing,objptr)
	EndMethod
	
	Function PrintColorSet(red:Float=1,green:Float=1,blue:Float=1,alpha:Float=1)
		_iPrintColorSet(red,green,blue,alpha)
	EndFunction
	
	Function PrintsHide()
		_iPrintsHide()
	EndFunction

	Method CameraSet(camera:CAMERA)
		_iFontCameraSet(objptr, camera.objptr)
	EndMethod

EndType

Function iFontCreate:FONT(wid_filename:String,cam:CAMERA,generateFunc:Byte Ptr=Null)
	Return _g_3IEngine.FontCreate(wid_filename,cam,generateFunc) 
EndFunction

Function iFontCreateFromMemory:FONT(wid_memfile_ptr:Byte Ptr,wid_memsize:Int,x_memfile_ptr:Byte Ptr[],x_memsize:Int[],texture_memfile_ptr:Byte Ptr,texture_memsize:Int,textureID:Int,cam:CAMERA,generateFunc:Byte Ptr=Null)
	Return _g_3IEngine.FontCreateFromMemory(wid_memfile_ptr,wid_memsize,x_memfile_ptr,x_memsize,texture_memfile_ptr,texture_memsize,textureID,cam,generateFunc)
EndFunction

Function iFontDestroy(fnt:FONT)
	fnt.Destroy()
EndFunction

Function iFontCameraSet(fnt:FONT, camera:CAMERA)
	fnt.CameraSet(camera)
EndFunction

Function iPrint(text:String,location:D3DXVECTOR2,scaling:D3DXVECTOR2,spacing:Float,fnt:FONT)
	fnt.Print(text,location,scaling,spacing)
EndFunction

Function iPrintCentered(text:String,location:D3DXVECTOR2,scaling:D3DXVECTOR2,spacing:Float,fnt:FONT,shrinkToWidth:Float)
	fnt.PrintCentered(text,location,scaling,spacing,shrinkToWidth)
EndFunction

Function iPrintWidth:Float(text:String,scaling:D3DXVECTOR2,spacing:Float,fnt:FONT)
	fnt.PrintWidth(text,scaling,spacing)
EndFunction

Function iPrintColorSet(red:Float=1,green:Float=1,blue:Float=1,alpha:Float=1)
	FONT.PrintColorSet(red,green,blue,alpha)
EndFunction

Function iPrintsHide()
	FONT.PrintsHide()
EndFunction


Extern
	' OUTPUT
	Function _iFontCreate:Byte Ptr(wid_filename$z,CAMERA:Byte Ptr)="iFontCreate" ' returns FONT*
	Function _iFontCreateFromMemory:Byte Ptr(wid_memfile_ptr:Byte Ptr,wid_memsize:Int,x_memfile_ptr_Array:Byte Ptr Ptr,x_memsize_Array:Int Ptr,texture_memfile_ptr:Byte Ptr,texture_memsize:Int,textureID:Int,CAMERA:Byte Ptr)="iFontCreateFromMemory" ' returns FONT*
	Function _iFontDestroy(FONT:Byte Ptr)="iFontDestroy"
	Function _iFontCameraSet(FONT:Byte Ptr, CAMERA:Byte Ptr) = "iFontCameraSet"

	Function _iPrint(text$z,D3DXVECTOR2_location:Byte Ptr,D3DXVECTOR2_scaling:Byte Ptr,spacing:Float,FONT:Byte Ptr)="iPrint"
	Function _iPrintCentered(text$z,D3DXVECTOR2_location:Byte Ptr,D3DXVECTOR2_scaling:Byte Ptr,spacing:Float,FONT:Byte Ptr,shrinkToWidth:Float)="iPrintCentered"
	Function _iPrintWidth:Float(text$z,D3DXVECTOR2_scaling:Byte Ptr,spacing:Float,FONT:Byte Ptr)="iPrintWidth"
	Function _iPrintColorSet(red:Float=1,green:Float=1,blue:Float=1,alpha:Float=1)="iPrintColorSet"
	Function _iPrintsHide()="iPrintsHide"

EndExtern
