Type REPLAYDATA Extends i3ImpactBase

	Method Destroy()
		_iReplayDataDestroy(objptr)
		objptr=Null
	EndMethod 
	
	Method Record:Int(floatArray:Float[])
		Return _iReplayDataRecord(objptr,Varptr(floatArray[0]))
	EndMethod 
	
	Method Play:Int(floatArray:Float[],bNoAdvance:Int)
		Return _iReplayDataPlay(objptr,Varptr(floatArray[0]),bNoAdvance)
	EndMethod 
	
	Method RecordReset()
		_iReplayDataRecordReset(objptr)
	EndMethod 
	
	Method PlayReset()
		_iReplayDataPlayReset(objptr)
	EndMethod 
	
	Method Time:Float()
		Return _iReplayDataTime(objptr)
	EndMethod 

	Method DataWrite(file:TCStream)
		_iReplayDataWrite(objptr,file._cstream)
	EndMethod
	
	Method DataRead(file:TCStream)
		_iReplayDataRead(objptr,file._cStream)
	EndMethod

	Method PlayPosition:Int()
		Return _iReplayDataPlayPosition(objptr)
	EndMethod
	
	Method PlayPositionSet(pos:Int)
		_iReplayDataPlayPositionSet(objptr,pos)
	EndMethod

EndType

Function iReplayDataCreate:REPLAYDATA(numFloatsToRecord:Int,maxRecordTime:Float,generateFunc:Byte Ptr=Null)
	Return _g_3IEngine.ReplayDataCreate(numFloatsToRecord,maxRecordTime,generateFunc)
EndFunction

Function iReplayDataDestroy(replay:REPLAYDATA)
	replay.Destroy()
EndFunction

Function iReplayDataRecord:Int(replay:REPLAYDATA,floatArray:Float[])
	Return replay.Record(floatArray)
EndFunction

Function iReplayDataPlay:Int(replay:REPLAYDATA,floatArray:Float[],bNoAdvance:Int)
	Return replay.Play(floatArray,bNoAdvance)
EndFunction

Function iReplayDataRecordReset(replay:REPLAYDATA)
	replay.RecordReset()
EndFunction

Function iReplayDataPlayReset(replay:REPLAYDATA)
	replay.PlayReset()
EndFunction

Function iReplayDataTime:Float(replay:REPLAYDATA)
	Return replay.Time()
EndFunction

Function iReplayDataWrite(replay:REPLAYDATA,file:TCStream)
	replay.DataWrite(file)
EndFunction

Function iReplayDataRead(replay:REPLAYDATA,file:TCStream)
	replay.DataRead(file)
EndFunction

Function iReplayDataPlayPosition:Int(replay:REPLAYDATA)
	Return replay.PlayPosition()
EndFunction

Function iReplayDataPlayPositionSet(replay:REPLAYDATA,pos:Int)
	replay.PlayPositionSet(pos)
EndFunction

Extern
	' REPLAY
	Function _iReplayDataCreate:Byte Ptr(numFloatsToRecord:Int,maxRecordTime:Float)="iReplayDataCreate" ' returns REPLAYDATA*
	
	Function _iReplayDataDestroy(REPLAYDATA:Byte Ptr)="iReplayDataDestroy"
	Function _iReplayDataRecord:Int(REPLAYDATA:Byte Ptr,floatArray:Float Ptr)="iReplayDataRecord" ' returns true/false
	Function _iReplayDataPlay:Int(REPLAYDATA:Byte Ptr,floatArray:Float Ptr,bNoAdvance:Int)="iReplayDataPlay" ' returns true/false
	Function _iReplayDataRecordReset(REPLAYDATA:Byte Ptr)="iReplayDataRecordReset"
	Function _iReplayDataPlayReset(REPLAYDATA:Byte Ptr)="iReplayDataPlayReset"
	Function _iReplayDataTime:Float(REPLAYDATA:Byte Ptr)="iReplayDataTime"
	Function _iReplayDataWrite(REPLAYDATA:Byte Ptr,HANDLE:Int)="iReplayDataWrite"
	Function _iReplayDataRead(REPLAYDATA:Byte Ptr,HANDLE:Int)="iReplayDataRead"
	Function _iReplayDataPlayPosition:Int(REPLAYDATA:Byte Ptr)="iReplayDataPlayPosition"
	Function _iReplayDataPlayPositionSet(REPLAYDATA:Byte Ptr,pos:Int)="iReplayDataPlayPositionSet"
EndExtern
