' SKINMESH
Type SKINMESH Extends i3ImpactBase	
	
	Method TexturesCount:Int()
		Return _iSkinMeshTexturesCount(objptr)
	EndMethod 
	
	Method Hide()
		_iSkinMeshHide(objptr)
	EndMethod 
	
	Method Show()
		_iSkinMeshShow(objptr)
	EndMethod 
	
	Method Destroy()
		_iSkinMeshDestroy(objptr)
		objptr=Null
	EndMethod 
	
	Method EulerOrientationSet(firstRotation:Float,secondRotation:Float,thirdRotation:Float,rotationOrder:String)
		_iSkinMeshEulerOrientationSet(objptr,firstRotation,secondRotation,thirdRotation,rotationOrder)
	EndMethod 
	
	Method OrientationSet(orientation:D3DXQUATERNION)
		_iSkinMeshOrientationSet(objptr,orientation.param())
	EndMethod 
	
	Method Orientation:D3DXQUATERNION(orientation:D3DXQUATERNION)
		_iSkinMeshOrientation(objptr,orientation.param())
		Return orientation
	EndMethod 
	
	Method OrientationAdd(rotation:D3DXVECTOR3,degressToAdd:Float)
		_iSkinMeshOrientationAdd(objptr,rotation.param(),degressToAdd)
	EndMethod 
	
	Method LocationSet(location:D3DXVECTOR3)
		_iSkinMeshLocationSet(objptr,location.param())
	EndMethod 
	
	Method Location:D3DXVECTOR3(location:D3DXVECTOR3) 
		_iSkinMeshLocation(objptr,location.param())
		Return location	
	EndMethod 

	Method AnimationSet:Int(str_param:String)
		Return _iSkinMeshAnimationSet(objptr, str_param)
	EndMethod
	
	Method AnimationSetSet(animation_id:Int, transition_time:Float, bUseSplineInterpolation:Int, bResetAnimation:Int)
		_iSkinMeshAnimationSetSet(objptr,animation_id,transition_time,bUseSplineInterpolation,bResetAnimation)
	EndMethod
	
	Method AnimationDataCompress(compression_ratio:Float)
		_iSkinMeshAnimationDataCompress(objptr,compression_ratio)
	EndMethod
	
	Method AnimationSetCount:Int()
		Return _iSkinMeshAnimationSetCount(objptr)
	EndMethod
	
	Method AnimationSpeedSet(speed:Float)
		_iSkinMeshAnimationSpeedSet(objptr,speed)
	EndMethod 
	
	Method AnimationTimeSet(AnimTime:Float)
		_iSkinMeshAnimationTimeSet(objptr,AnimTime)
	EndMethod 
	
	Method AnimationTime:Float()
		Return _iSkinMeshAnimationTime(objptr)
	EndMethod 
	
	Method AnimationLength:Float()
		Return _iSkinMeshAnimationLength(objptr)
	EndMethod 
	
	Method RenderModeSet(D3DRENDERSTATE_SRCBLEND_factor:Int,D3DRENDERSTATE_DESTBLEND_factor:Int,bUseZBuffer:Int,bRenderAfterShadows:Int=False)
		_iSkinMeshRenderModeSet(objptr,D3DRENDERSTATE_SRCBLEND_factor,D3DRENDERSTATE_DESTBLEND_factor,bUseZBuffer,bRenderAfterShadows)
	EndMethod 
	
	Method RenderPrioritySet(priority:Int)
		_iSkinMeshRenderPrioritySet(objptr,priority)
	EndMethod 
		
	Method EnvMapCasterAdd()
		_iSkinMeshEnvMapCasterAdd(objptr)
	EndMethod 
	
	Method EnvMapCasterRemove()
		_iSkinMeshEnvMapCasterRemove(objptr)
	EndMethod 
	
	Method Visible:Int(cam:CAMERA)
		_iSkinMeshVisible(cam.objptr,objptr)
	EndMethod 
	
	Method BoundingSphereRayCheck:Int(origin:D3DXVECTOR3,direction:D3DXVECTOR3)
		Return _iSkinMeshBoundingSphereRayCheck(objptr,origin.param(),direction.param())
	EndMethod 
	
	Method Transfer(bdy:BODY)
		_iSkinMeshTransfer(objptr,bdy.objptr)
	EndMethod 
	
	Method BonesCount:Int()
		Return _iSkinMeshBonesCount(objptr)
	EndMethod 

	Method BoneCreate:SKINMESHBONE(boneIDX:Int,generateFunc:Byte Ptr=Null)
		Local retval:SKINMESHBONE
		If generateFunc<>Null
			Local genFunc:SKINMESHBONE()=generateFunc
			retval=genFunc()
		Else
			retval=_g_3IEngine.generateSkinMeshBone()
		EndIf
		retval.objptr=_iSkinMeshBoneCreate(objptr,boneIDX)
		If retval.objptr<>Null Then Return retval Else Return Null
	EndMethod
	
	Method BoneCreateByName:SKINMESHBONE(boneName:String,generateFunc:Byte Ptr=Null)
		Local retval:SKINMESHBONE
		If generateFunc<>Null
			Local genFunc:SKINMESHBONE()=generateFunc
			retval=genFunc()
		Else
			retval=_g_3IEngine.generateSkinMeshBone()
		EndIf
		retval.objptr=_iSkinMeshBoneCreateByName(objptr,boneName)
		If retval.objptr<>Null Then Return retval Else Return Null
	EndMethod
	
	Method BoundingSphere:Float(center:D3DXVECTOR3)
		Return _iSkinMeshBoundingSphere(objptr,center.param())
	EndMethod

	Method EffectValueSet(constant_name:String,data_buffer:Byte Ptr,buffer_length:Int)
		_iSkinMeshEffectValueSet(objptr,constant_name,data_buffer,buffer_length)
	EndMethod

	Method EffectTextureSet(texture_name:String,tex:TEXTURE)
		_iSkinMeshEffectTextureSet(objptr,texture_name,tex.objptr)
	EndMethod

	Method EffectDefaultEnable(bMatrices:Int,bMaterials:Int,bTexture:Int)
		_iSkinMeshEffectDefaultEnable(objptr,bMatrices,bMaterials,bTexture)
	EndMethod

	Method ScaleSet(scaleX:Float,scaleY:Float,scaleZ:Float)
		_iSkinMeshScaleSet(objptr,scaleX,scaleY,scaleZ)
	EndMethod 

	Method Picked:Int(cam:CAMERA)
		Return _iSkinMeshPicked(cam.objptr,objptr)
	EndMethod
	
	Method RayCheck:Int(origin:D3DXVECTOR3,direction:D3DXVECTOR3)
		Return _iSkinMeshRayCheck(objptr,origin.param(),direction.param())
	EndMethod
	
	Method TextureMipMapLodSet(LOD:Float)
		_iSkinMeshTextureMipMapLodSet(objptr,LOD)
	EndMethod

	Method EffectEnvTextureSet(texture_name:String,ENVMAP:Byte Ptr)
		_iSkinMeshEffectEnvTextureSet(objptr,texture_name,ENVMAP)
	EndMethod
	
	Method EffectCreate:Byte Ptr(effect_filename:String,generateFunc:Byte Ptr=Null)
		Local retval:Byte Ptr = Null

		If generateFunc<>Null
			Local genFunc:Byte Ptr(effect_filename:String)=generateFunc
			retval=genFunc(effect_filename)
		Else
			retval=_g_3IEngine.generateSkinMeshEffect(effect_filename)
		EndIf

		Return retval
	EndMethod
	
	Method EffectDestroy(EFFECT:Byte Ptr)
		_iSkinMeshEffectDestroy(EFFECT)
	EndMethod
	
	Method EffectSet(EFFECT:Byte Ptr)
		_iSkinMeshEffectSet(objptr,EFFECT)
	EndMethod
	
EndType

Function iSkinMeshCreate:SKINMESH(x_filename:String,shader_filename:String,generateFunc:Byte Ptr=Null)
	Return _g_3IEngine.SkinMeshCreate(x_filename,shader_filename,generateFunc)
EndFunction

Function iSkinMeshCreateFromMemory:SKINMESH(x_filemem_ptr:Byte Ptr,x_memsize:Int,images:Byte Ptr[],imgSizes:Int[],shader_filename:String,generateFunc:Byte Ptr=Null)
	Return _g_3IEngine.SkinMeshCreateFromMemory(x_filemem_ptr,x_memsize,images,imgSizes,shader_filename,generateFunc)
EndFunction

Function iSkinMeshTexturesCount:Int(skmsh:SKINMESH)
	Return skmsh.TexturesCount()
EndFunction

Function iSkinMeshHide(skmsh:SKINMESH)
	skmsh.Hide()
EndFunction

Function iSkinMeshShow(skmsh:SKINMESH)
	skmsh.Show()
EndFunction

Function iSkinMeshDestroy(skmsh:SKINMESH)
	skmsh.Destroy()
EndFunction

Function iSkinMeshEulerOrientationSet(skmsh:SKINMESH,firstRotation:Float,secondRotation:Float,thirdRotation:Float,rotationOrder:String)
	skmsh.EulerOrientationSet(firstRotation,secondRotation,thirdRotation,rotationOrder)
EndFunction

Function iSkinMeshOrientationSet(skmsh:SKINMESH,orientation:D3DXQUATERNION)
	skmsh.OrientationSet(orientation)
EndFunction

Function iSkinMeshOrientation:D3DXQUATERNION(skmsh:SKINMESH,orientation:D3DXQUATERNION)
	skmsh.Orientation(orientation)
	Return orientation
EndFunction

Function iSkinMeshOrientationAdd(skmsh:SKINMESH,rotation:D3DXVECTOR3,degressToAdd:Float)
	skmsh.OrientationAdd(rotation,degressToAdd)
EndFunction

Function iSkinMeshLocationSet(skmsh:SKINMESH,location:D3DXVECTOR3)
	skmsh.LocationSet(location)
EndFunction

Function iSkinMeshLocation:D3DXVECTOR3(skmsh:SKINMESH,location:D3DXVECTOR3) 
	skmsh.Location(location)
	Return location	
EndFunction

Function iSkinMeshAnimationSet:Int(skmsh:SKINMESH,str_param:String)
	Return skmsh.AnimationSet(str_param)
EndFunction

Function iSkinMeshAnimationSetSet(skmsh:SKINMESH,animation_id:Int,transition_time:Float,bUseSplineInterpolation:Int,bResetAnimation:Int)
	skmsh.AnimationSetSet(animation_id,transition_time,bUseSplineInterpolation,bResetAnimation)
EndFunction

Function iSkinMeshAnimationDataCompress(skmsh:SKINMESH,compression_ratio:Float)
	skmsh.AnimationDataCompress(compression_ratio)
EndFunction

Function iSkinMeshAnimationSetCount:Int(skmsh:SKINMESH)
	Return skmsh.AnimationSetCount()
EndFunction

Function iSkinMeshAnimationSpeedSet(skmsh:SKINMESH,speed:Float)
	skmsh.AnimationSpeedSet(speed)
EndFunction

Function iSkinMeshAnimationTimeSet(skmsh:SKINMESH,AnimTime:Float)
	skmsh.AnimationTimeSet(AnimTime)
EndFunction

Function iSkinMeshAnimationTime:Float(skmsh:SKINMESH)
	Return skmsh.AnimationTime()
EndFunction

Function iSkinMeshAnimationLength:Float(skmsh:SKINMESH)
	Return skmsh.AnimationLength()
EndFunction

Function iSkinMeshRenderModeSet(skmsh:SKINMESH,D3DRENDERSTATE_SRCBLEND_factor:Int,D3DRENDERSTATE_DESTBLEND_factor:Int,bUseZBuffer:Int,bRenderAfterShadows:Int=False)
	skmsh.RenderModeSet(D3DRENDERSTATE_SRCBLEND_factor,D3DRENDERSTATE_DESTBLEND_factor,bUseZBuffer,bRenderAfterShadows)
EndFunction

Function iSkinMeshRenderPrioritySet(skmsh:SKINMESH,priority:Int)
	skmsh.RenderPrioritySet(priority)
EndFunction

Function iSkinMeshEnvMapCasterAdd(skmsh:SKINMESH)
	skmsh.EnvMapCasterAdd()
EndFunction

Function iSkinMeshEnvMapCasterRemove(skmsh:SKINMESH)
	skmsh.EnvMapCasterRemove()
EndFunction

Function iSkinMeshVisible:Int(cam:CAMERA,skmsh:SKINMESH)
	skmsh.Visible(cam)
EndFunction

Function iSkinMeshBoundingSphereRayCheck:Int(skmsh:SKINMESH,origin:D3DXVECTOR3,direction:D3DXVECTOR3)
	Return skmsh.BoundingSphereRayCheck(origin,direction)
EndFunction

Function iSkinMeshTransfer(skmsh:SKINMESH,bdy:BODY)
	skmsh.Transfer(bdy)
EndFunction

Function iSkinMeshBonesCount:Int(skmsh:SKINMESH)
	Return skmsh.BonesCount()
EndFunction

Function iSkinMeshBoundingSphere:Float(skmsh:SKINMESH,center:D3DXVECTOR3)
	Return skmsh.BoundingSphere(center)
EndFunction

Function iSkinMeshEffectValueSet(skmsh:SKINMESH,constant_name:String,data_buffer:Byte Ptr,buffer_length:Int)
	skmsh.EffectValueSet(constant_name,data_buffer,buffer_length)
EndFunction

Function iSkinMeshEffectTextureSet(skmsh:SKINMESH,texture_name:String,tex:TEXTURE)
	skmsh.EffectTextureSet(texture_name,tex)
EndFunction

Function iSkinMeshEffectDefaultEnable(skmsh:SKINMESH,bMatrices:Int,bMaterials:Int,bTexture:Int)
	skmsh.EffectDefaultEnable(bMatrices,bMaterials,bTexture)
EndFunction

Function iSkinMeshBoneCreate:SKINMESHBONE(skmsh:SKINMESH,boneIDX:Int,generateFunc:Byte Ptr=Null)
	Return skmsh.BoneCreate(boneIDX,generateFunc)
EndFunction

Function iSkinMeshBoneCreateByName:SKINMESHBONE(skmsh:SKINMESH,boneName:String,generateFunc:Byte Ptr=Null)
	Return skmsh.BoneCreateByName(boneName,generateFunc)
EndFunction

Function iSkinMeshScaleSet(skmsh:SKINMESH,scaleX:Float,scaleY:Float,scaleZ:Float)
	skmsh.ScaleSet(scaleX,scaleY,scaleZ)
EndFunction

Function iSkinMeshPicked:Int(cam:CAMERA,skmsh:SKINMESH)
	Return skmsh.Picked(cam)
EndFunction

Function iSkinMeshRayCheck:Int(skmsh:SKINMESH,origin:D3DXVECTOR3,direction:D3DXVECTOR3)
	Return skmsh.RayCheck(origin,direction)
EndFunction

Function iSkinMeshTextureMipMapLodSet(skmsh:SKINMESH,LOD:Float)
	skmsh.TextureMipMapLodSet(LOD)
EndFunction

Function iSkinMeshEffectEnvTextureSet(skmsh:SKINMESH,texture_name:String,ENVMAP:Byte Ptr)
	skmsh.EffectEnvTextureSet(texture_name,ENVMAP)
EndFunction

Function iSkinMeshEffectCreate:Byte Ptr(effect_filename:String)
	Return _g_3IEngine.generateSkinMeshEffect(effect_filename)
EndFunction

Function iSkinMeshEffectDestroy(EFFECT:Byte Ptr)
	_iSkinMeshEffectDestroy(EFFECT)
EndFunction

Function iSkinMeshEffectSet(skmsh:SKINMESH,EFFECT:Byte Ptr)
	Return skmsh.EffectSet(EFFECT)
EndFunction

Type SKINMESHBONE Extends i3ImpactBase	

	Method Destroy()
		_iSkinMeshBoneDestroy(objptr)
		objptr=Null
	EndMethod
	
	Method ChildFind:SKINMESHBONE(childIDX:Int)
		Local retval:SKINMESHBONE=_g_3IEngine.generateSkinMeshBone()
		retval.objptr=_iSkinMeshBoneChildFind(objptr,childIDX)
		If retval.objptr<>Null Then Return retval Else Return Null
	EndMethod
	
	Method ParentFind:SKINMESHBONE()
		Local retval:SKINMESHBONE=_g_3IEngine.generateSkinMeshBone()
		retval.objptr=_iSkinMeshBoneParentFind(objptr)
		If retval.objptr<>Null Then Return retval Else Return Null
	EndMethod
	
	Method Orientation:D3DXQUATERNION(orientation:D3DXQUATERNION,orientationType:Int)
		_iSkinMeshBoneOrientation(objptr,orientation.param(),orientationType)
		Return orientation
	EndMethod
	
	Method OrientationSet(orientation:D3DXQUATERNION,orientationType:Int)
		_iSkinMeshBoneOrientationSet(objptr,orientation.param(),orientationType)
	EndMethod
	
	Method LookAt(lookAt:D3DXVECTOR3,upDirection:D3DXVECTOR3)
		_iSkinMeshBoneLookAt(objptr,lookAt.param(),upDirection.param())
	EndMethod
	
	Method Location:D3DXVECTOR3(location:D3DXVECTOR3,locationType:Int)
		_iSkinMeshBoneLocation(objptr,location.param(),locationType)
		Return location
	EndMethod
	
	Method LocationSet(location:D3DXVECTOR3)
		_iSkinMeshBoneLocationSet(objptr,location.param())
	EndMethod
	
	Method Scaling:D3DXVECTOR3(scaling:D3DXVECTOR3)
		_iSkinMeshBoneScaling(objptr,scaling.param())
		Return scaling
	EndMethod
	
	Method ScalingSet(scaling:D3DXVECTOR3)
		_iSkinMeshBoneScalingSet(objptr,scaling.param())
	EndMethod
	
	Method Name(name:String Var)
		Local buf:TBank=CreateBank(1024)
		_iSkinMeshBoneName(objptr,BankBuf(buf))
		name=String.FromCString(BankBuf(buf))
		buf=Null
	EndMethod
EndType

Function iSkinMeshBoneDestroy(skmshbn:SKINMESHBONE)
	skmshbn.Destroy()
EndFunction

Function iSkinMeshBoneChildFind:SKINMESHBONE(skmshbn:SKINMESHBONE,childIDX:Int)
	Return skmshbn.ChildFind(childIDX)
EndFunction

Function iSkinMeshBoneParentFind:SKINMESHBONE(skmshbn:SKINMESHBONE)
	Return skmshbn.ParentFind()
EndFunction

Function iSkinMeshBoneOrientation:D3DXQUATERNION(skmshbn:SKINMESHBONE,orientation:D3DXQUATERNION,orientationType:Int)
	skmshbn.Orientation(orientation,orientationType)
	Return orientation
EndFunction

Function iSkinMeshBoneOrientationSet(skmshbn:SKINMESHBONE,orientation:D3DXQUATERNION,orientationType:Int)
	skmshbn.OrientationSet(orientation,orientationType)
EndFunction

Function iSkinMeshBoneLookAt(skmshbn:SKINMESHBONE,lookAt:D3DXVECTOR3,upDirection:D3DXVECTOR3)
	skmshbn.LookAt(lookAt,upDirection)
EndFunction

Function iSkinMeshBoneLocation:D3DXVECTOR3(skmshbn:SKINMESHBONE,location:D3DXVECTOR3,locationType:Int)
	skmshbn.Location(location,locationType)
	Return location
EndFunction

Function iSkinMeshBoneLocationSet(skmshbn:SKINMESHBONE,location:D3DXVECTOR3)
	skmshbn.LocationSet(location)
EndFunction

Function iSkinMeshBoneScaling:D3DXVECTOR3(skmshbn:SKINMESHBONE,scaling:D3DXVECTOR3)
	skmshbn.Scaling(scaling)
	Return scaling
EndFunction

Function iSkinMeshBoneScalingSet(skmshbn:SKINMESHBONE,scaling:D3DXVECTOR3)
	skmshbn.ScalingSet(scaling)
EndFunction

Function iSkinMeshBoneName(skmshbn:SKINMESHBONE,name:String Var)
	skmshbn.Name(name)
EndFunction

Extern

	' SKINMESH
	Function _iSkinMeshCreate:Byte Ptr(x_filename$z,shader_filename:Byte Ptr)="iSkinMeshCreate" ' returns SKINMESH* 
	Function _iSkinMeshCreateFromMemory:Byte Ptr(x_filemem_ptr:Byte Ptr,x_memsize:Int,imgArray:Byte Ptr Ptr,imgSizeArray:Int Ptr,shader_filename:Byte Ptr)="iSkinMeshCreateFromMemory" ' returns SKINMESH*
	Function _iSkinMeshTexturesCount:Int(SKINMESH:Byte Ptr)="iSkinMeshTexturesCount"
	Function _iSkinMeshHide(SKINMESH:Byte Ptr)="iSkinMeshHide"
	Function _iSkinMeshShow(SKINMESH:Byte Ptr)="iSkinMeshShow"
	Function _iSkinMeshDestroy(SKINMESH:Byte Ptr)="iSkinMeshDestroy"
	Function _iSkinMeshEulerOrientationSet(SKINMESH:Byte Ptr,firstRotation:Float,secondRotation:Float,thirdRotation:Float,rotationOrder$z)="iSkinMeshEulerOrientationSet"
	Function _iSkinMeshOrientationSet(SKINMESH:Byte Ptr,D3DXQUATERNION_orientation:Byte Ptr)="iSkinMeshOrientationSet"
	Function _iSkinMeshOrientation:Byte Ptr(SKINMESH:Byte Ptr,D3DXQUATERNION_orientation:Byte Ptr)="iSkinMeshOrientation" ' returns D3DXQUATERNION*
	Function _iSkinMeshOrientationAdd(SKINMESH:Byte Ptr,D3DXVECTOR3_rotation:Byte Ptr,degressToAdd:Float)="iSkinMeshOrientationAdd"
	Function _iSkinMeshLocationSet(SKINMESH:Byte Ptr,D3DXVECTOR3_location:Byte Ptr)="iSkinMeshLocationSet"
	Function _iSkinMeshLocation:Byte Ptr(SKINMESH:Byte Ptr,D3DXVECTOR3:Byte Ptr)="iSkinMeshLocation" ' returns D3DXVECTOR3* 
	Function _iSkinMeshAnimationSpeedSet(SKINMESH:Byte Ptr,speed:Float)="iSkinMeshAnimationSpeedSet"
	Function _iSkinMeshAnimationTimeSet(SKINMESH:Byte Ptr,AnimTime:Float)="iSkinMeshAnimationTimeSet"
	Function _iSkinMeshAnimationTime:Float(SKINMESH:Byte Ptr)="iSkinMeshAnimationTime"
	Function _iSkinMeshAnimationLength:Float(SKINMESH:Byte Ptr)="iSkinMeshAnimationLength"
	Function _iSkinMeshRenderModeSet(SKINMESH:Byte Ptr,D3DRENDERSTATE_SRCBLEND_factor:Int,D3DRENDERSTATE_DESTBLEND_factor:Int,bUseZBuffer:Int,bRenderAfterShadows:Int=False)="iSkinMeshRenderModeSet"
	Function _iSkinMeshRenderPrioritySet(SKINMESH:Byte Ptr,priority:Int)="iSkinMeshRenderPrioritySet"
	Function _iSkinMeshEnvMapCasterAdd(SKINMESH:Byte Ptr)="iSkinMeshEnvMapCasterAdd"
	Function _iSkinMeshEnvMapCasterRemove(SKINMESH:Byte Ptr)="iSkinMeshEnvMapCasterRemove"
	Function _iSkinMeshVisible:Int(CAMERA:Byte Ptr,SKINMESH:Byte Ptr)="iSkinMeshVisible" ' returns true/false
	Function _iSkinMeshBoundingSphereRayCheck:Int(SKINMESH:Byte Ptr,D3DXVECTOR3_origin:Byte Ptr,D3DXVECTOR3_direction:Byte Ptr)="iSkinMeshBoundingSphereRayCheck" ' returns true/false
	Function _iSkinMeshTransfer(SKINMESH:Byte Ptr,BODY:Byte Ptr)="iSkinMeshTransfer"
	Function _iSkinMeshBonesCount:Int(SKINMESH:Byte Ptr)="iSkinMeshBonesCount"
	Function _iSkinMeshBoneCreate:Byte Ptr(SKINMESH:Byte Ptr,boneIDX:Int)="iSkinMeshBoneCreate" ' returns SKINMESHBONE*
	Function _iSkinMeshBoneCreateByName:Byte Ptr(SKINMESH:Byte Ptr,boneName$z)="iSkinMeshBoneCreateByName" ' returns SKINMESHBONE*
	Function _iSkinMeshBoneDestroy(SKINMESHBONE:Byte Ptr)="iSkinMeshBoneDestroy"
	Function _iSkinMeshBoneChildFind:Byte Ptr(SKINMESHBONE:Byte Ptr,childIDX:Int)="iSkinMeshBoneChildFind" ' returns SKINMESHBONE*
	Function _iSkinMeshBoneParentFind:Byte Ptr(SKINMESHBONE:Byte Ptr)="iSkinMeshBoneParentFind" ' returns SKINMESHBONE*
	Function _iSkinMeshBoneOrientation:Byte Ptr(SKINMESHBONE:Byte Ptr,D3DXQUATERNION_orientation:Byte Ptr,orientationType:Int)="iSkinMeshBoneOrientation" ' returns D3DXQUATERNION* 
	Function _iSkinMeshBoneOrientationSet(SKINMESHBONE:Byte Ptr,D3DXQUATERNION_orientation:Byte Ptr,orientationType:Int)="iSkinMeshBoneOrientationSet"
	Function _iSkinMeshBoneLookAt(SKINMESHBONE:Byte Ptr,D3DXVECTOR3_lookAt:Byte Ptr,D3DXVECTOR3_upDirection:Byte Ptr)="iSkinMeshBoneLookAt"
	Function _iSkinMeshBoneLocation:Byte Ptr(SKINMESHBONE:Byte Ptr,D3DXVECTOR3_location:Byte Ptr,locationType:Int)="iSkinMeshBoneLocation" ' returns D3DXVECTOR3* 
	Function _iSkinMeshBoneLocationSet(SKINMESHBONE:Byte Ptr,D3DXVECTOR3_location:Byte Ptr)="iSkinMeshBoneLocationSet"
	Function _iSkinMeshBoneScaling:Byte Ptr(SKINMESHBONE:Byte Ptr,D3DXVECTOR3_scaling:Byte Ptr)="iSkinMeshBoneScaling" ' returns D3DXVECTOR3*
	Function _iSkinMeshBoneScalingSet(SKINMESHBONE:Byte Ptr,D3DXVECTOR3_scaling:Byte Ptr)="iSkinMeshBoneScalingSet"
	Function _iSkinMeshBoneName(SKINMESHBONE:Byte Ptr,name:Byte Ptr)="iSkinMeshBoneName"

	' new in v5.1
	Function _iSkinMeshBoundingSphere:Float(SKINMESH:Byte Ptr,D3DXVECTOR3_center:Byte Ptr)="iSkinMeshBoundingSphere"
	Function _iSkinMeshEffectValueSet(SKINMESH:Byte Ptr,constant_name$z,data_buffer:Byte Ptr,buffer_length:Int)="iSkinMeshEffectValueSet"
	Function _iSkinMeshEffectTextureSet(SKINMESH:Byte Ptr,texture_name$z,TEXTURE:Byte Ptr)="iSkinMeshEffectTextureSet"
	Function _iSkinMeshEffectDefaultEnable(SKINMESH:Byte Ptr,bMatrices:Int,bMaterials:Int,bTexture:Int)="iSkinMeshEffectDefaultEnable"
	Function _iSkinMeshScaleSet(SKINMESH:Byte Ptr,scaleX:Float,scaleY:Float,scaleZ:Float)="iSkinMeshScaleSet"

	' new in v5.3
	Function _iSkinMeshEffectEnvTextureSet(SKINMESH:Byte Ptr,texture_name$z,ENVMAP:Byte Ptr) = "iSkinMeshEffectEnvTextureSet"
	Function _iSkinMeshEffectCreate:Byte Ptr(effect_filename$z) = "iSkinMeshEffectCreate"
	Function _iSkinMeshEffectDestroy(EFFECT:Byte Ptr) = "iSkinMeshEffectDestroy"
	Function _iSkinMeshEffectSet(SKINMESH:Byte Ptr,EFFECT:Byte Ptr) = "iSkinMeshEffectSet"
	Function _iSkinMeshPicked:Int(CAMERA:Byte Ptr,SKINMESH:Byte Ptr) = "iSkinMeshPicked"
	Function _iSkinMeshRayCheck:Int(SKINMESH:Byte Ptr,D3DXVECTOR3_origin:Byte Ptr,D3DXVECTOR3_direction:Byte Ptr) = "iSkinMeshRayCheck"
	Function _iSkinMeshTextureMipMapLodSet(SKINMESH:Byte Ptr,LOD:Float) = "iSkinMeshTextureMipMapLodSet"
	
	' new in v5.7
	Function _iSkinMeshAnimationSet:Int(SKINMESH:Byte Ptr,str_param$z) = "iSkinMeshAnimationSet"
	Function _iSkinMeshAnimationSetSet(SKINMESH:Byte Ptr,animation_id:Int,transition_time:Float,bUseSplineInterpolation:Int,bResetAnimation:Int) = "iSkinMeshAnimationSetSet"
	Function _iSkinMeshAnimationDataCompress(SKINMESH:Byte Ptr,compression_ratio:Float) = "iSkinMeshAnimationDataCompress"
	Function _iSkinMeshAnimationSetCount:Int(SKINMESH:Byte Ptr) = "iSkinMeshAnimationSetCount"

EndExtern
